=== test/ctest/CMakeLists.txt ===
########## Check example parameter files (checks only the return value -> SUCCESS/FAILURE)
# Basic
add_test(
    NAME    check_basic_example_param_file
    COMMAND aevol_create_2b ${PROJECT_SOURCE_DIR}/examples/basic/param.in)
set_tests_properties(
    check_basic_example_param_file
    PROPERTIES LABELS "TEST;aevol_2b;example_param_files")
# Virus
add_test(
    NAME    check_virus_example_param_file
    COMMAND aevol_create_2b ${PROJECT_SOURCE_DIR}/examples/virus/param.in)
set_tests_properties(
    check_virus_example_param_file
    PROPERTIES LABELS "TEST;aevol_2b;example_param_files")
# Eukaryote. Contains 2 param files: one for the prokaryotic bootstrap and one for the acual eukaryote experiment
add_test(
    NAME    check_eukaryote_bootstrap_example_param_file
    COMMAND aevol_create_2b ${PROJECT_SOURCE_DIR}/examples/eukaryote/prokaryote_bootstrap/param.in)
set_tests_properties(
    check_eukaryote_bootstrap_example_param_file
    PROPERTIES LABELS "TEST;aevol_2b;example_param_files")
add_test(
    NAME    check_eukaryote_example_param_file
    COMMAND aevol_create_eukaryote_2b ${PROJECT_SOURCE_DIR}/examples/eukaryote/param.in --fasta ${PROJECT_SOURCE_DIR}/examples/eukaryote/WT0.fa)
set_tests_properties(
    check_eukaryote_example_param_file
    PROPERTIES LABELS "TEST;aevol_eukaryote_2b;example_param_files")
