=== src/post_treatments/libaevol_post/CMakeLists.txt ===
# ============================================================================
# Libaevol-post is a library that contains classes shared by several
# post-treatments
# ============================================================================

foreach (AEVOL_FLAVOR IN LISTS AEVOL_FLAVORS)
  add_library(lib${AEVOL_FLAVOR}-post
      neutral_mutation_output.cpp
      neutral_mutation_output.h)
  target_link_libraries(lib${AEVOL_FLAVOR}-post PRIVATE lib${AEVOL_FLAVOR})
  set_target_properties(lib${AEVOL_FLAVOR}-post PROPERTIES PREFIX "")

  target_include_directories(lib${AEVOL_FLAVOR}-post PUBLIC ".")
endforeach (AEVOL_FLAVOR)
