## aevol 4.2

=== debian/changelog ===
aevol (4.2-1) unstable; urgency=low

  * Initial release (Closes: #718887)

 -- David Parsons <david.parsons@inria.fr>  Fri, 22 Nov 2013 16:10:43 +0100
