## aevol 4.3

=== debian/changelog ===
aevol (4.3-1) unstable; urgency=low

  * New upstream version
  * Bumped Standards-Version to 3.9.5 (no changes needed)

 -- David Parsons <david.parsons@inria.fr>  Wed, 23 Apr 2014 15:18:40 +0100
