## aevol 4.4

=== debian/changelog ===
aevol (4.4-1) unstable; urgency=low

  * New upstream version

 -- David Parsons <david.parsons@inria.fr>  Thu, 31 Jul 2014 23:58:27 +0200
