=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                zlib1g-dev,
                autotools-dev,
                libx11-dev
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/aevol/trunk/
 Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/aevol/trunk/
 Homepage: http://www.aevol.fr/
