=== debian/watch ===
version=3
http://www.aevol.fr/download/index.php http://gforge.liris.cnrs.fr/frs/download.php/.*/aevol-(.*)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip)
