## aevol 5.0

=== debian/changelog ===
aevol (5.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Moved packaging from SVN to Git
  * Fixed watch file
  * debhelper 10
  * Standards-Version: 4.1.0 (no changes needed)
  * Add missing libboost Build-Depends
  * hardening=+all
  * Unique license name

 -- Andreas Tille <tille@debian.org>  Mon, 11 Sep 2017 20:47:37 +0200
