=== debian/control ===
--- 
+++ 
@@ -3,13 +3,15 @@
 Uploaders: David Parsons <david.parsons@inria.fr>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9.0),
+Build-Depends: debhelper (>= 10),
                zlib1g-dev,
-               autotools-dev,
-               libx11-dev
-Standards-Version: 3.9.5
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/aevol/trunk/
-Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/aevol/trunk/
+               libx11-dev,
+               libboost-dev,
+               libboost-system-dev,
+               libboost-filesystem-dev
+Standards-Version: 4.1.0
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/aevol.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/aevol.git
 Homepage: http://www.aevol.fr/
 
 Package: aevol
@@ -33,4 +35,3 @@
  The simulation platform comes along with a set of tools for analysing
  phylogenies and measuring many characteristics of the organisms and
  populations along evolution.
-
