=== debian/watch ===
version=4
http://www.aevol.fr/download/ https://gforge.inria.fr/frs/download.php/file/.*/aevol-(\d[.\d]+)@ARCHIVE_EXT@
