## aevol 5.0%2Bds

=== debian/changelog ===
aevol (5.0+ds-4ubuntu4) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@debian.org>  Tue, 03 Feb 2026 21:36:46 +0100

aevol (5.0+ds-4ubuntu3) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:10:08 +0200

aevol (5.0+ds-4ubuntu2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:59:43 +0200

aevol (5.0+ds-4ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable (LP: #2098425). Remaining change:
    - debian/patches/fix-buffer-overflow.patch: avoid possible buffer
      overflows (LP: #2071412).

 -- Matthieu Clemenceau <matthieu.clemenceau@canonical.com>  Thu, 13 Feb 2025 23:54:15 +0000

aevol (5.0+ds-4) unstable; urgency=medium

  * Team upload.
  * d/control: migrate to mpi-default-dev. (Closes: #1088626)
  * d/watch: upstream forge moved to gitlab.inria.fr.
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Thu, 28 Nov 2024 22:24:35 +0100

aevol (5.0+ds-3ubuntu1) oracular; urgency=medium

  * debian/patches/fix-buffer-overflow.patch: avoid possible buffer
    overflows.  Closes LP: #2071412.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 06 Sep 2024 07:57:48 -0700

aevol (5.0+ds-3build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:45:36 +0100

aevol (5.0+ds-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Do not call AM_INIT_AUTOMAKE twice
    Closes: #998479
  * Standards-Version: 4.6.0 (routine-update)

  [ Étienne Mollier ]
  * Remove now unneeded maintainer manual pages.
  * Add groff-message.patch to fix multiple typos in the comment marker '.\"'.

 -- Étienne Mollier <emollier@debian.org>  Fri, 05 Nov 2021 22:39:02 +0100

aevol (5.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 17 Dec 2020 15:53:43 +0100

aevol (5.0+ds-1) unstable; urgency=medium

  * Team upload.
  * Strip m4 files and once at stripping unnneded autogenerated files
    from automake
    Closes: #933628
  * Build-Depends: libopenmpi-dev
  * Build-Depends: autoconf-archive
  * Remove debug code from autopkgtest

 -- Andreas Tille <tille@debian.org>  Thu, 01 Aug 2019 13:20:27 +0200

aevol (5.0-3) unstable; urgency=medium

  * Team upload.

  [ Jelmer Vernooĳ ]
  * Use secure copyright file specification URI.

  [ Andreas Tille ]
  * Add copyright for src/libaevol/SFMT-src-1.4
  * debhelper-compat 12
  * Standards-Version: 4.4.0

  [ Saira Hussain ]
  * Add autopkgtest

 -- Saira Hussain <saira.h0213@zoho.com>  Thu, 25 Jul 2019 09:13:49 +0100

aevol (5.0-2) unstable; urgency=medium

  * Team upload.
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Tue, 25 Sep 2018 11:05:21 +0200
