## aevol 5.0+ds

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,19 @@
 Uploaders: David Parsons <david.parsons@inria.fr>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 13),
                zlib1g-dev,
                libx11-dev,
                libboost-dev,
                libboost-system-dev,
-               libboost-filesystem-dev
-Standards-Version: 4.1.0
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/aevol.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/aevol.git
+               libboost-filesystem-dev,
+               mpi-default-dev,
+               autoconf-archive
+Standards-Version: 4.7.0
+Vcs-Browser: https://salsa.debian.org/med-team/aevol
+Vcs-Git: https://salsa.debian.org/med-team/aevol.git
 Homepage: http://www.aevol.fr/
+Rules-Requires-Root: no
 
 Package: aevol
 Architecture: any
