=== debian/watch ===
version=4
opts=" \
	mode=git, \
	repacksuffix=+ds, \
	dversionmangle=auto, \
	repack, \
	compression=xz \
" \
https://gitlab.inria.fr/aevol/aevol.git \
refs/tags/v?(\d[\.\d]+)
