## aevol 9.3.0

=== debian/changelog ===
aevol (9.3.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * d/watch: version=5
  * Drop libboost-system-dev from Build-Depends
    Closes: #1127160
  * Standards-Version: 4.7.3 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)
  * Reorder Files paragraphs in debian/copyright by directory depth.
  * Use secure URI in Homepage field.
  * Remove duplicate values for fields Author, Author, Author, Entry, Entry,
    Name, Title in debian/upstream/metadata.
  * Build-Depends: cmake, nlohmann-json3-dev, googletest, libgtest-dev
  * d/copyright: No need to remove files any more

 -- Andreas Tille <tille@debian.org>  Tue, 10 Feb 2026 08:19:02 +0100
