=== debian/control ===
--- 
+++ 
@@ -2,19 +2,20 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: David Parsons <david.parsons@inria.fr>
 Section: science
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               cmake,
                zlib1g-dev,
                libx11-dev,
                libboost-dev,
-               libboost-system-dev,
                libboost-filesystem-dev,
                mpi-default-dev,
-               autoconf-archive
-Standards-Version: 4.7.0
+               nlohmann-json3-dev,
+               googletest,
+               libgtest-dev
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/aevol
 Vcs-Git: https://salsa.debian.org/med-team/aevol.git
-Homepage: http://www.aevol.fr/
+Homepage: https://www.aevol.fr/
 Rules-Requires-Root: no
 
 Package: aevol
