=== debian/rules ===
--- 
+++ 
@@ -8,3 +8,6 @@
 
 %:
 	dh $@
+
+override_dh_auto_test:
+	PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/bin:$(PATH) dh_auto_test
