=== debian/watch ===
Version: 5

Source: https://gitlab.inria.fr/aevol/aevol.git
Matching-Pattern: refs/tags/@ANY_VERSION@
Mode: git
